//+------------------------------------------------------------------+
//|                                                                  |
//|                                                                  |
//|                        TradeBand.mq4                             |
//|                                                                  |
//|                                                                  | 
//+------------------------------------------------------------------+ 

#property  copyright "TRO_Tunnel_dragon, Copyright  2008"
//  Avery T. Horton, Jr. aka TRO, PO BOX 43575, TUCSON, AZ 85733,
//  therumpledone@gmail.com " 

/*---------------------------------------------------------------------
TradeBand:

This indicator is based on code in the referenced copyright indicator.
Some code was removed, some added.  Additions enhance the indicator by
making it "preserve" user choices of colors and linestyles.

                                      - Traderathome, December 26, 2008
----------------------------------------------------------------------*/

#property indicator_chart_window 

#property indicator_buffers  3

#property indicator_color1   DodgerBlue 
#property indicator_color2   Red
#property indicator_color3   DodgerBlue
#property indicator_width1   1
#property indicator_width2   1
#property indicator_width3   1
#property indicator_style1   STYLE_SOLID
#property indicator_style2   STYLE_SOLID
#property indicator_style3   STYLE_SOLID

// indicators parameters
extern bool   Show.PriceBox  = false ;

extern string    notetype    = "0=SMA,1=EMA,2=SMMA,3=LWMA" ;
extern string    noteprice   = "0=CLOSE,1=OPEN,2=HIGH,3=LOW,4=MEDIAN,5=PP,6=WEIGHT" ;
extern int       MA_Period1  = 34 ;
extern int       MAType1     = 1;
extern int       MAPrice1    = PRICE_HIGH ;

extern int       MA_Period2  = 34 ;
extern int       MAType2     = 1;
extern int       MAPrice2    = PRICE_MEDIAN ;

extern int       MA_Period3  = 34 ;
extern int       MAType3     = 1;
extern int       MAPrice3    = PRICE_LOW ;

//---- buffers
double P0Buffer[];
double P1Buffer[];
double P2Buffer[];

string tP0Buf = "drma_01" ;
string tP1Buf = "drma_02" ;
string tP2Buf = "drma_03" ;

int   myPeriod        = 0 ;
int   myShift         = 0 ;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- name for indicator window
   string short_name=" ";
   IndicatorShortName(short_name);
   SetIndexBuffer(0, P0Buffer);
   SetIndexBuffer(1, P1Buffer);
   SetIndexBuffer(2, P2Buffer);
 
//----
   SetIndexStyle(0, DRAW_LINE);
   SetIndexStyle(1, DRAW_LINE);   
   SetIndexStyle(2, DRAW_LINE);

// setting the indicator values, which will be invisible on the chart
   SetIndexEmptyValue(0,0); 
   SetIndexEmptyValue(1,0);
   SetIndexEmptyValue(2,0); 
   
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
   ObjectDelete(tP0Buf);
   ObjectDelete(tP1Buf);
   ObjectDelete(tP2Buf);         
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
{
   datetime TimeArray[];
   int i, dayi, counted_bars = IndicatorCounted();
//---- check for possible errors
   if(counted_bars < 0) 
       return(-1);
//---- last counted bar will be recounted
   if(counted_bars > 0) 
       counted_bars--;  
   int limit = Bars - counted_bars;
//----   
   for(i = limit - 1; i >= 0; i--)   //---- Tricolor indicator code 
     {
     int BarShift = iBarShift(NULL,myPeriod,Time[i+myShift],true);         
     P0Buffer[i] = iMA(NULL,myPeriod, MA_Period1,0,MAType1,MAPrice1,BarShift);       
     P1Buffer[i] = iMA(NULL,myPeriod,MA_Period2,0,MAType2,MAPrice2,BarShift); 
     P2Buffer[i] = iMA(NULL,myPeriod,MA_Period3 ,0,MAType3,MAPrice3,BarShift);       
     }	 

if(Show.PriceBox) 
  { 
  if (ObjectFind(tP0Buf) != 0)
      {     
    //ObjectCreate(tP0Buf,OBJ_HLINE,0,Time[0],X01);         
      ObjectCreate(tP0Buf,OBJ_ARROW,0,Time[0],P0Buffer[0]);
      ObjectSet(tP0Buf,OBJPROP_ARROWCODE,SYMBOL_RIGHTPRICE);
      ObjectSet(tP0Buf,OBJPROP_COLOR,indicator_color1);  
      } 
  else
      {
      ObjectMove(tP0Buf,0,Time[0],P0Buffer[0]);
      }
    
  if (ObjectFind(tP1Buf) != 0)
      {
       ObjectCreate(tP1Buf,OBJ_ARROW,0,Time[0],P1Buffer[0]);
       ObjectSet(tP1Buf,OBJPROP_ARROWCODE,SYMBOL_RIGHTPRICE);
       ObjectSet(tP1Buf,OBJPROP_COLOR,indicator_color2);  
      } 
  else
      {
      ObjectMove(tP1Buf,0,Time[0],P1Buffer[0]);
      }

  if (ObjectFind(tP2Buf) != 0)
      {
      ObjectCreate(tP2Buf,OBJ_ARROW,0,Time[0],P2Buffer[0]);
      ObjectSet(tP2Buf,OBJPROP_ARROWCODE,SYMBOL_RIGHTPRICE);
      ObjectSet(tP2Buf,OBJPROP_COLOR,indicator_color3);  
      } 
  else
      {
      ObjectMove(tP2Buf,0,Time[0],P2Buffer[0]);
      }
      
  }   	
   return(0);
}
//----------------------End Program------------------------------------